--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_8xx.S.ADEOS	Thu Oct 30 01:32:14 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_8xx.S	Mon Jun  7 22:49:48 2004
@@ -231,7 +231,11 @@
 	bl	transfer_to_handler
 	.globl	do_IRQ_intercept
 do_IRQ_intercept:
-	.long	do_IRQ;
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_irq_intercept
+#else /* !CONFIG_ADEOS_CORE */
+	.long	do_IRQ
+#endif /* CONFIG_ADEOS_CORE */
 	.long	ret_from_intercept
 
 /* Alignment exception */
@@ -268,7 +272,11 @@
 	bl	transfer_to_handler
 	.globl	timer_interrupt_intercept
 timer_interrupt_intercept:
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_timer_intercept;
+#else /* !CONFIG_ADEOS_CORE */
 	.long	timer_interrupt
+#endif /* CONFIG_ADEOS_CORE */
 	.long	ret_from_intercept
 
 	STD_EXCEPTION(0xa00, Trap_0a, UnknownException)
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head.S.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head.S
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head.S.ADEOS	Sat Nov 15 02:31:44 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head.S	Mon Jun  7 22:49:48 2004
@@ -435,7 +435,11 @@
 	bl	transfer_to_handler
 	.globl do_IRQ_intercept
 do_IRQ_intercept:
-	.long	do_IRQ;
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_irq_intercept
+#else /* !CONFIG_ADEOS_CORE */
+	.long	do_IRQ
+#endif /* CONFIG_ADEOS_CORE */
 	.long	ret_from_intercept
 
 /* Alignment exception */
@@ -485,7 +489,11 @@
 	bl	transfer_to_handler
 	.globl timer_interrupt_intercept
 timer_interrupt_intercept:
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_timer_intercept;
+#else /* !CONFIG_ADEOS_CORE */
 	.long	timer_interrupt
+#endif /* CONFIG_ADEOS_CORE */
 	.long	ret_from_intercept
 
 	STD_EXCEPTION(0xa00, Trap_0a, UnknownException)
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/idle.c.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/idle.c
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/idle.c.ADEOS	Thu Oct 30 01:32:14 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/idle.c	Mon Jun  7 22:49:48 2004
@@ -67,6 +67,9 @@
 		if (do_power_save && !current->need_resched)
 			power_save();
 
+#ifdef CONFIG_ADEOS_CORE
+		adeos_suspend_domain();
+#endif /* CONFIG_ADEOS_CORE */
 		if (current->need_resched) {
 			schedule();
 			check_pgt_cache();
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/irq.c.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/irq.c
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/irq.c.ADEOS	Sat Nov 15 02:11:32 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/irq.c	Mon Jun  7 22:49:48 2004
@@ -433,7 +433,13 @@
 
 	kstat.irqs[cpu][irq]++;
 	spin_lock(&desc->lock);
+#ifdef CONFIG_ADEOS_CORE
+	if (!adp_pipelined) 
+		ack_irq(irq);
+#else
 	ack_irq(irq);
+#endif /* CONFIG_ADEOS_CORE */
+
 	/*
 	   REPLAY is when Linux resends an IRQ that was dropped earlier
 	   WAITING is used by probe to mark irqs that are being tested
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/Makefile.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/Makefile
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/Makefile.ADEOS	Thu May  6 23:20:13 2004
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/Makefile	Mon Jun  7 22:49:48 2004
@@ -34,7 +34,8 @@
 export-objs			:= ppc_ksyms.o time.o ocp.o ppc4xx_setup.o \
 					ppc4xx_dma.o ppc4xx_sgdma.o \
 					ppc4xx_stbdma.o ppc4xx_pm.o \
-					gt64260_common.o mpc5xxx_common.o
+					gt64260_common.o mpc5xxx_common.o \
+					adeos.o
 
 obj-y				:= entry.o traps.o irq.o idle.o time.o misc.o \
 					process.o signal.o ptrace.o align.o \
@@ -86,6 +87,7 @@
 endif
 endif
 
+obj-$(CONFIG_ADEOS_CORE)	+= adeos.o
 obj-$(CONFIG_MBX)		+= i8259.o
 obj-$(CONFIG_ALL_PPC)		+= prom_init.o prom.o open_pic.o \
 					indirect_pci.o i8259.o
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/misc.S.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/misc.S
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/misc.S.ADEOS	Thu Oct 30 01:32:14 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/misc.S	Mon Jun  7 22:49:48 2004
@@ -200,8 +200,12 @@
 	mr	r4,r24
 	bctr
 
+#ifdef CONFIG_ADEOS_CORE
+_GLOBAL(adeos_hw_save_flags_ptr)
+#else /* !CONFIG_ADEOS_CORE */
 /* void __save_flags_ptr(unsigned long *flags) */
 _GLOBAL(__save_flags_ptr)
+#endif /* CONFIG_ADEOS_CORE */
 	mfmsr	r4
 	stw	r4,0(r3)
 	blr
@@ -229,8 +233,12 @@
 	nop
 _GLOBAL(__save_flags_ptr_end)
 
+#ifdef CONFIG_ADEOS_CORE
+_GLOBAL(adeos_hw_restore_flags)
+#else /* !CONFIG_ADEOS_CORE */
 /* void __restore_flags(unsigned long flags) */
 _GLOBAL(__restore_flags)
+#endif /* CONFIG_ADEOS_CORE */
 /*
  * Just set/clear the MSR_EE bit through restore/flags but do not
  * change anything else.  This is needed by the RT system and makes
@@ -270,7 +278,11 @@
 	nop
 _GLOBAL(__restore_flags_end)
 
+#ifdef CONFIG_ADEOS_CORE
+_GLOBAL(adeos_hw_cli)
+#else /* !CONFIG_ADEOS_CORE */
 _GLOBAL(__cli)
+#endif /* CONFIG_ADEOS_CORE */
 	mfmsr	r0		/* Get current interrupt state */
 	rlwinm	r3,r0,16+1,32-1,31	/* Extract old value of 'EE' */
 	rlwinm	r0,r0,0,17,15	/* clear MSR_EE in r0 */
@@ -299,7 +311,11 @@
 	nop
 _GLOBAL(__cli_end)
 
+#ifdef CONFIG_ADEOS_CORE
+_GLOBAL(adeos_hw_sti)
+#else /* !CONFIG_ADEOS_CORE */
 _GLOBAL(__sti)
+#endif /* CONFIG_ADEOS_CORE */
 	mfmsr	r3		/* Get current state */
 	ori	r3,r3,MSR_EE	/* Turn on 'EE' bit */
 	SYNC			/* Some chip revs have problems here... */
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/ppc_ksyms.c.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/ppc_ksyms.c
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/ppc_ksyms.c.ADEOS	Tue Mar 16 11:40:04 2004
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/ppc_ksyms.c	Mon Jun  7 22:49:48 2004
@@ -314,6 +314,7 @@
 #endif
 
 EXPORT_SYMBOL(__delay);
+#ifndef CONFIG_ADEOS_CORE
 EXPORT_SYMBOL(__sti);
 EXPORT_SYMBOL(__sti_end);
 EXPORT_SYMBOL(__cli);
@@ -322,6 +323,7 @@
 EXPORT_SYMBOL(__save_flags_ptr_end);
 EXPORT_SYMBOL(__restore_flags);
 EXPORT_SYMBOL(__restore_flags_end);
+#endif
 EXPORT_SYMBOL(timer_interrupt_intercept);
 EXPORT_SYMBOL(timer_interrupt);
 EXPORT_SYMBOL(do_IRQ_intercept);
@@ -409,3 +411,34 @@
 extern unsigned long gt64260_base;
 EXPORT_SYMBOL(gt64260_base);
 #endif /* CONFIG_GT64260 */
+
+#ifdef CONFIG_ADEOS_CORE
+#ifdef CONFIG_ADEOS_MODULE
+EXPORT_SYMBOL(adp_pipelined);
+EXPORT_SYMBOL(__adeos_timer_virq);
+EXPORT_SYMBOL(adeos_do_IRQ);
+EXPORT_SYMBOL(adeos_timer_interrupt);
+#endif /* CONFIG_ADEOS_MODULE */
+EXPORT_SYMBOL(adeos_hw_sti);
+EXPORT_SYMBOL(adeos_hw_cli);
+EXPORT_SYMBOL(adeos_hw_save_flags_ptr);
+EXPORT_SYMBOL(adeos_hw_restore_flags);
+EXPORT_SYMBOL(adeos_critical_enter);
+EXPORT_SYMBOL(adeos_critical_exit);
+EXPORT_SYMBOL(adeos_trigger_irq);
+EXPORT_SYMBOL(__adeos_sync_stage);
+EXPORT_SYMBOL(__adeos_irq_regs);
+#ifdef FIXME
+EXPORT_SYMBOL(__adeos_tune_timer);
+#endif
+EXPORT_SYMBOL(__adeos_switch_domain);
+EXPORT_SYMBOL(__adeos_handle_irq);
+/* The following are per-platform convenience exports which are needed
+   by some Adeos domains loaded as kernel modules. */
+#ifdef FIXME
+EXPORT_SYMBOL_NOVERS(__switch_to);
+#endif
+extern void show_regs(struct pt_regs * regs);
+EXPORT_SYMBOL_NOVERS(show_regs);
+#endif /* CONFIG_ADEOS_CORE */
+
+ diff -u linuxppc_2_4_devel-D2004-05-07/Documentation/adeos.txt.ADEOS linuxppc_2_4_devel-D2004-05-07/Documentation/adeos.txt
--- linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/adeos.h.ADEOS	Tue Jun 15 12:06:37 2004
+++ linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/adeos.h	Mon Jun  7 22:50:41 2004
@@ -0,0 +1,308 @@
+/*
+ *   include/asm-ppc/adeos.h
+ *
+ *   Copyright (C) 2004 Wolfgang Grandegger.
+ *   Copyright (C) 2002 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#ifndef __PPC_ADEOS_H
+#define __PPC_ADEOS_H
+
+struct task_struct;
+
+#include <asm/irq.h>
+#include <asm/siginfo.h>
+#include <asm/ptrace.h>
+#include <asm/bitops.h>
+#include <linux/list.h>
+#include <linux/threads.h>
+
+#define ADEOS_ARCH_STRING "ppc"
+
+#ifdef CONFIG_ADEOS_MODULE
+extern int adp_pipelined;
+#else  /* !CONFIG_ADEOS_MODULE */
+#define adp_pipelined 1		/* Testing this should be optimized out. */
+#endif /* CONFIG_ADEOS_MODULE */
+
+
+#define ADEOS_IRQ_ACKED		0x1000
+#define ADEOS_IRQ_ACKED_MASK	(ADEOS_IRQ_ACKED - 1)
+
+#define ADEOS_NR_CPUS          1
+#define adeos_processor_id()   0
+/* Array references using this index should be optimized out. */
+#define adeos_declare_cpuid    const int cpuid = 0
+#define adeos_load_cpuid()      /* nop */
+#define adeos_lock_cpu(flags)   adeos_hw_local_irq_save(flags)
+#define adeos_unlock_cpu(flags) adeos_hw_local_irq_restore(flags)
+#define adeos_get_cpu(flags)    do { flags = flags; } while(0)
+#define adeos_put_cpu(flags)    /* nop */
+#define adp_current             (adp_cpu_current[0])
+
+ /* ARM fault traps */
+#define ADEOS_NR_FAULTS         32
+/* Pseudo-vectors used for kernel events */
+#define ADEOS_FIRST_KEVENT      ADEOS_NR_FAULTS
+#define ADEOS_SYSCALL_PROLOGUE  (ADEOS_FIRST_KEVENT)
+#define ADEOS_SYSCALL_EPILOGUE  (ADEOS_FIRST_KEVENT + 1)
+#define ADEOS_SCHEDULE_HEAD     (ADEOS_FIRST_KEVENT + 2)
+#define ADEOS_SCHEDULE_TAIL     (ADEOS_FIRST_KEVENT + 3)
+#define ADEOS_ENTER_PROCESS     (ADEOS_FIRST_KEVENT + 4)
+#define ADEOS_EXIT_PROCESS      (ADEOS_FIRST_KEVENT + 5)
+#define ADEOS_SIGNAL_PROCESS    (ADEOS_FIRST_KEVENT + 6)
+#define ADEOS_KICK_PROCESS      (ADEOS_FIRST_KEVENT + 7)
+#define ADEOS_RENICE_PROCESS    (ADEOS_FIRST_KEVENT + 8)
+#define ADEOS_USER_EVENT        (ADEOS_FIRST_KEVENT + 9)
+#define ADEOS_LAST_KEVENT       (ADEOS_USER_EVENT)
+
+#define ADEOS_NR_EVENTS         (ADEOS_LAST_KEVENT + 1)
+
+typedef struct adevinfo {
+
+    unsigned domid;
+    unsigned event;
+    void *evdata;
+
+    volatile int propagate;	/* Private */
+
+} adevinfo_t;
+
+typedef struct adsysinfo {
+
+    int ncpus;			/* Number of CPUs on board */
+
+    unsigned long long cpufreq;	/* CPU frequency (in Hz) */
+
+    /* Arch-dependent block */
+
+    struct {
+	unsigned tmirq;		/* Timer tick IRQ */
+    } archdep;
+
+} adsysinfo_t;
+
+#define IPIPE_NR_XIRQS   NR_IRQS
+/* Number of virtual IRQs */
+#define IPIPE_NR_VIRQS   BITS_PER_LONG
+/* First virtual IRQ # */
+#define IPIPE_VIRQ_BASE  (((IPIPE_NR_XIRQS + BITS_PER_LONG - 1) / BITS_PER_LONG) * BITS_PER_LONG)
+/* Total number of IRQ slots */
+#define IPIPE_NR_IRQS     (IPIPE_VIRQ_BASE + IPIPE_NR_VIRQS)
+/* Number of indirect words needed to map the whole IRQ space. */
+#define IPIPE_IRQ_IWORDS  ((IPIPE_NR_IRQS + BITS_PER_LONG - 1) / BITS_PER_LONG)
+#define IPIPE_IRQ_IMASK   (BITS_PER_LONG - 1)
+#define IPIPE_IRQ_ISHIFT  5	/* 2^5 for 32bits arch. */
+
+#define IPIPE_IRQMASK_ANY   (~0L)
+#define IPIPE_IRQMASK_VIRT  (IPIPE_IRQMASK_ANY << (IPIPE_VIRQ_BASE / BITS_PER_LONG))
+
+typedef struct adomain {
+
+    /* -- Section: offset-based references are made on these fields
+       from inline assembly code. Please don't move or reorder. */
+    void (*dswitch)(void);	/* Domain switch hook */
+    int *esp[ADEOS_NR_CPUS];	/* Domain stack pointers */
+    /* -- End of section. */
+
+    int *estackbase[ADEOS_NR_CPUS];
+
+    unsigned long flags;
+
+    unsigned domid;
+
+    const char *name;
+
+    int priority;
+
+    struct adcpudata {
+	unsigned long status;
+	unsigned long irq_pending_hi;
+	unsigned long irq_pending_lo[IPIPE_IRQ_IWORDS];
+	unsigned irq_hits[IPIPE_NR_IRQS];
+	adevinfo_t event_info;
+    } cpudata[ADEOS_NR_CPUS];
+
+    struct {
+	int (*acknowledge)(unsigned irq);
+	void (*handler)(unsigned irq);
+	unsigned long control;
+    } irqs[IPIPE_NR_IRQS];
+
+    struct {
+	void (*handler)(adevinfo_t *evinfo);
+    } events[ADEOS_NR_EVENTS];
+
+    int ptd_keymax;
+    int ptd_keycount;
+    unsigned long ptd_keymap;
+    void (*ptd_setfun)(int, void *);
+    void *(*ptd_getfun)(int);
+
+    struct adomain *m_link;	/* Link in mutex sleep queue */
+
+    struct list_head p_link;	/* Link in pipeline */
+
+} adomain_t;
+
+typedef struct admutex {
+
+    spinlock_t lock;
+
+    adomain_t *sleepq, /* Pending domains queue */
+	      *owner;	/* Domain owning the mutex */
+
+#define ADEOS_MUTEX_UNLOCKED { SPIN_LOCK_UNLOCKED, NULL, NULL }
+
+} admutex_t;
+
+#define __clear_bit(nr,addr) clear_bit(nr,addr)
+#define __test_bit(nr,addr)  test_bit(nr,addr)
+
+/* The following macros must be used hw interrupts off. */
+
+#define __adeos_set_irq_bit(adp,cpuid,irq) \
+do { \
+    if (!test_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) { \
+        __set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+        __set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+       } \
+} while(0)
+
+#define __adeos_clear_pend(adp,cpuid,irq) \
+do { \
+    __clear_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+    if (&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT] == 0) \
+        __clear_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+} while(0)
+
+#define __adeos_lock_irq(adp,cpuid,irq) \
+do { \
+    if (!test_and_set_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	__adeos_clear_pend(adp,cpuid,irq); \
+} while(0)
+
+#define __adeos_unlock_irq(adp,irq) \
+do { \
+    int __cpuid, __nr_cpus = smp_num_cpus;			       \
+    if (test_and_clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++)      \
+         if ((adp)->cpudata[__cpuid].irq_hits[irq] > 0) { \
+           set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[__cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+           set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[__cpuid].irq_pending_hi); \
+         } \
+} while(0)
+
+#define __adeos_clear_irq(adp,irq) \
+do { \
+    int __cpuid, __nr_cpus = smp_num_cpus; \
+    clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control); \
+    for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++) {	\
+       (adp)->cpudata[__cpuid].irq_hits[irq] = 0; \
+       __adeos_clear_pend(adp,__cpuid,irq); \
+    } \
+} while(0)
+
+#define adeos_virtual_irq_p(irq) ((irq) >= IPIPE_VIRQ_BASE && \
+				  (irq) < IPIPE_NR_IRQS)
+
+#define adeos_hw_local_irq_disable()		adeos_hw_cli()
+#define adeos_hw_local_irq_enable()		adeos_hw_sti()
+#define adeos_hw_local_irq_save(flags)		adeos_hw_save_and_cli(flags)
+#define adeos_hw_local_irq_set(flags)		adeos_hw_save_and_sti(flags)
+#define adeos_hw_local_irq_restore(flags)	adeos_hw_restore_flags(flags)
+#define adeos_hw_local_irq_flags(flags)	asm volatile("mfmsr %0" : "=r" (flags))
+#define adeos_hw_test_iflag(x)		((x) & MSR_EE)
+#define adeos_hw_irqs_disabled()	\
+({					\
+	unsigned long flags;		\
+	adeos_hw_local_irq_flags(flags);\
+	!adeos_hw_test_iflag(flags);	\
+})
+
+#define adeos_hw_tsc(t)  0
+#define adeos_cpu_freq() CLOCK_TICK_RATE
+
+#ifdef CONFIG_PREEMPT
+#define adeos_spin_lock(x)    _raw_spin_lock(x)
+#define adeos_spin_unlock(x)  _raw_spin_unlock(x)
+#define adeos_spin_trylock(x) _raw_spin_trylock(x)
+#else /* !CONFIG_PREEMPT */
+#define adeos_spin_lock(x)    spin_lock(x)
+#define adeos_spin_unlock(x)  spin_unlock(x)
+#define adeos_spin_trylock(x) spin_trylock(x)
+#endif /* CONFIG_PREEMPT */
+
+#define adeos_spin_lock_irqsave(x,flags)       do { adeos_hw_local_irq_save(flags); adeos_spin_lock(x); } while (0)
+#define adeos_spin_unlock_irqrestore(x,flags)  do { adeos_spin_unlock(x); adeos_hw_local_irq_restore(flags); } while (0)
+#define adeos_spin_lock_disable(x)             do { adeos_hw_cli(); adeos_spin_lock(x); } while (0)
+#define adeos_spin_unlock_enable(x)            do { adeos_spin_unlock(x); adeos_hw_sti(); } while (0)
+
+/* Private interface -- Internal use only */
+
+struct adattr;
+
+void __adeos_init(void);
+
+void __adeos_init_domain(adomain_t *adp,
+			 struct adattr *attr);
+
+void __adeos_cleanup_domain(adomain_t *adp);
+
+#define __adeos_check_machine() do { } while(0)
+
+void __adeos_enable_pipeline(void);
+
+void __adeos_disable_pipeline(void);
+
+void __adeos_init_stage(adomain_t *adp);
+
+void FASTCALL(__adeos_sync_stage(unsigned long syncmask));
+
+#ifdef FIXME
+void __adeos_tune_timer(unsigned long hz);
+#endif
+
+int adeos_do_IRQ(int irq, struct pt_regs *regs);
+
+int adeos_timer_interrupt(int irq, struct pt_regs *regs);
+
+int __adeos_handle_irq(int irq, struct pt_regs *regs);
+
+int __adeos_switch_domain(adomain_t *adp, adomain_t **currentp);
+
+static inline void __adeos_switch_to(adomain_t *adp, int cpuid) {
+
+    extern adomain_t *adp_cpu_current[];
+    unsigned long flags;
+
+    adeos_hw_local_irq_save(flags);
+    __adeos_switch_domain(adp,&adp_cpu_current[cpuid]);
+    adeos_hw_local_irq_restore(flags);
+
+    if (adp_cpu_current[adeos_processor_id()]->dswitch != NULL)
+	adp_cpu_current[adeos_processor_id()]->dswitch();
+}
+
+extern struct pt_regs __adeos_irq_regs;
+
+extern unsigned long __adeos_virtual_irq_map;
+
+extern int __adeos_timer_virq;
+
+#endif /* !__PPC_ADEOS_H */
+ diff -u linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/hw_irq.h.ADEOS linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/hw_irq.h
--- linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/hw_irq.h.ADEOS	Thu Oct 30 01:34:05 2003
+++ linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/hw_irq.h	Mon Jun  7 22:49:48 2004
@@ -10,6 +10,17 @@
 extern int timer_interrupt(struct pt_regs *);
 extern void ppc_irq_dispatch_handler(struct pt_regs *regs, int irq);
 
+#ifdef CONFIG_ADEOS_CORE
+extern void adeos_hw_sti(void);
+extern void adeos_hw_cli(void);
+extern void adeos_hw_restore_flags(unsigned long);
+extern void adeos_hw_save_flags_ptr(unsigned long *);
+extern unsigned long __sti_end, __cli_end, __restore_flags_end, __save_flags_ptr_end;
+
+#define adeos_hw_save_flags(flags) adeos_hw_save_flags_ptr((unsigned long *)&flags)
+#define adeos_hw_save_and_cli(flags) ({adeos_hw_save_flags(flags);adeos_hw_cli();})
+#define adeos_hw_save_and_sti(flags) ({adeos_hw_save_flags(flags);adeos_hw_sti();})
+#else /* !CONFIG_ADEOS_CORE */
 extern void __sti(void);
 extern void __cli(void);
 extern void __restore_flags(unsigned long);
@@ -19,6 +30,7 @@
 #define __save_flags(flags) __save_flags_ptr((unsigned long *)&flags)
 #define __save_and_cli(flags) ({__save_flags(flags);__cli();})
 #define __save_and_sti(flags) ({__save_flags(flags);__sti();})
+#endif /* CONFIG_ADEOS_CORE */
 
 extern void do_lost_interrupts(unsigned long);
 
+ diff -u linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/system.h.ADEOS linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/system.h
--- linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/system.h.ADEOS	Thu Oct 30 01:34:06 2003
+++ linuxppc_2_4_devel-D2004-05-07/include/asm-ppc/system.h	Mon Jun  7 22:49:48 2004
@@ -81,8 +81,28 @@
 extern void note_scsi_host(struct device_node *, void *);
 
 struct task_struct;
+
+#ifdef CONFIG_ADEOS_CORE
+
+#define prepare_to_switch(prev,next) \
+do { \
+    struct { struct task_struct *prev, *next; } arg = { (prev), (next) }; \
+    __adeos_schedule_head(&arg); \
+    adeos_hw_cli(); \
+} while(0)
+#define switch_to(prev,next,last)		\
+	do {			 		\
+		_switch_to(prev,next,&(last));	\
+		mb();	/* FIXME */		\
+		adeos_hw_sti();			\
+	} while (0)
+#else /* !CONFIG_ADEOS_CORE */
+
 #define prepare_to_switch()	do { } while(0)
 #define switch_to(prev,next,last) _switch_to((prev),(next),&(last))
+
+#endif /* CONFIG_ADEOS_CORE */
+
 extern void _switch_to(struct task_struct *, struct task_struct *,
 		       struct task_struct **);
 
@@ -95,6 +115,25 @@
 struct pt_regs;
 extern void dump_regs(struct pt_regs *);
 
+#ifdef CONFIG_ADEOS_CORE
+
+extern inline void __adeos_stall_root(void);
+extern inline void __adeos_unstall_root(void);
+extern inline unsigned long __adeos_test_root(void);
+extern inline unsigned long __adeos_test_and_stall_root(void);
+void __adeos_restore_root(unsigned long flags);
+
+#define __cli() 		__adeos_stall_root()
+#define __sti()			__adeos_unstall_root()
+#define __save_flags(x)		((x) = __adeos_test_root())
+#define __restore_flags(x) 	__adeos_restore_root(x)
+
+#define __save_and_cli(x)	do { __save_flags(x); __cli(); } while(0);
+//#define __save_and_cli(x)	((x) = __adeos_test_and_stall_root())
+#define __save_and_sti(x)	do { __save_flags(x); __sti(); } while(0);
+
+#endif /* CONFIG_ADEOS_CORE */
+
 #ifndef CONFIG_SMP
 
 #define cli()	__cli()
+ diff -u linuxppc_2_4_devel-D2004-05-07/include/linux/adeos.h.ADEOS linuxppc_2_4_devel-D2004-05-07/include/linux/adeos.h
